package cn.ibizlab.assetmanagement.core.workorder.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.workorder.domain.EAMWOType;
import cn.ibizlab.assetmanagement.core.workorder.filter.EAMWOTypeSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMWOType] 服务对象接口
 */
public interface IEAMWOTypeService extends IService<EAMWOType>{

    boolean create(EAMWOType et) ;
    void createBatch(List<EAMWOType> list) ;
    boolean update(EAMWOType et) ;
    void updateBatch(List<EAMWOType> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMWOType get(String key) ;
    EAMWOType getDraft(EAMWOType et) ;
    boolean checkKey(EAMWOType et) ;
    boolean save(EAMWOType et) ;
    void saveBatch(List<EAMWOType> list) ;
    Page<EAMWOType> searchDefault(EAMWOTypeSearchContext context) ;
    List<EAMWOType> selectByEamwostatemodelid(String eamwostatemodelid) ;
    void removeByEamwostatemodelid(String eamwostatemodelid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMWOType> getEamwotypeByIds(List<String> ids) ;
    List<EAMWOType> getEamwotypeByEntities(List<EAMWOType> entities) ;
}


